# PAX - the Pythonic API for XML
# developed by Lalo Martins <lalo@laranja.org>
# this file is placed on public domain

# copes with broken browsers for stuff like
# <textarea />, <a />, <select /> etc

from textpaxparser import *
from textpaxparser import _parse_in_progress as _text_parse
from utils import XML

broken = (
    'textarea',
    'select',
    'a',
    'div',
    )

raw = (
    'script',
    'style',
    )

class Broken_HTML_Element(core.Element):
    def __children_xml__(self, prefix, ns_map):
        return u'>' + XML(self.children, ns_map) + u'</' + prefix + self.name + u'>'

class Raw_HTML_Element(core.Element):
    def __children_xml__(self, prefix, ns_map):
        return u'>' + u''.join(self) + u'</' + prefix + self.name + u'>'

class _parse_in_progress(_text_parse):
    def handle_starttag(self, rawname, raw_attributes):
        _text_parse.handle_starttag(self, rawname, raw_attributes)
        element = self.stack[-1]
        if element.name in broken:
            element.__class__ = Broken_HTML_Element
        if element.name in raw:
            element.__class__ = Raw_HTML_Element

def parse(data, builtin_namespaces=None, encoding=None):
    if encoding is None:
        # FIXME: can we get the encoding from the HTML?
        encoding = 'latin1'
    if type(data) is type(''):
        data = unicode(data, encoding)
    parser = _parse_in_progress()
    if builtin_namespaces is not None:
        parser.namespaces.append(builtin_namespaces)
    parser.feed(data)
    parser.close()
    return parser.result
